#include <iostream>
#include "i3d/image3d.h"
#include "threshold.h"
#include "histogram.h"

using namespace std;
using namespace i3d;


void ProcessCells(void)
{
	//opens and reads GRAY 8bit input image
	Image3d<GRAY8> img;
	img.ReadImageBMP("images/cell02_2D_GRAY8.bmp");

	//vypocitame si histogram
	int histogram[256];
	ComputeHistogram(img,histogram);

	//DEBUG: vypise histogram na obrazovku
	/*
	for (int i=0; i < 256; ++i)
		cout << i << " " << histogram[i] << "\n";
	*/

	int threshold=0;
	threshold=SuggestThreshold(histogram);
	cout << "Suggested threshold is " << threshold << endl;

	cout << "Doing some thresholding.\n";
	Threshold(img,threshold);

	//trik jak udelat z obrazu s hodnotami 0,1
	//obraz s hodnotami 0,100
	img.GetVoxelData() *= 100;
	img.SaveImageBMP("images/cell02_2D_GRAY8_thresholded.bmp");
}


void TestHistograms(void) {
		//opens and reads GRAY 8bit input image
		Image3d<GRAY8> img;
		img.ReadImageBMP("images/birds2_GRAY8.bmp");

		ComputeHistogram_MyList(img);
		ComputeHistogram_MyListOpt(img);
		ComputeHistogram_StdMap(img);
}


int main(void) {
	try {
		//chytani vyjimek, umoznuje zobrazit chybova hlaseni knihoven i3dlibs
		//tato konstrukce rika, ze v tomto bloku {...} se maji chytat vyjimky

		ProcessCells();
		TestHistograms();

		//pokud se program dostal az sem, nenastal zadny problem
		return(0);

	} //konec bloku "try" - chytani ruznych vyjimek
	catch (const char *e)
	{
		cout << e << endl;
	}
	catch (std::string &e)
	{
		cout << e << endl;
	}
	catch (i3d::IOException& e)
	{
		cout << e << endl;
	}
	catch (i3d::InternalException& e)
	{
		cout << e << endl;
	}
	catch (std::bad_alloc&)
	{
		cout << "Not enough memory." << endl;
	}
	catch (...)
	{
		cout << "System exception." << endl;
	}

	//pokud se program dostal sem, nastal predtim nejaky problem
	return(1);
}
