#include "i3d/image3d.h"
#include "threshold.h"

using namespace i3d;

void Threshold(Image3d<GRAY8> &img,const GRAY8 thres)
{
	GRAY8 *p=img.GetFirstVoxelAddr();
	for (size_t i=0; i < img.GetImageSize(); ++i, ++p)
	{
		*p=(*p > thres)? 1 : 0;
	}
}

int SuggestThreshold(const int (&histogram)[256])
{
	//find the maximum skipping a few left most (smallest) intensities
	int L=5;
	int max_val=0;

	for (int i=L; i < 256; ++i)
	{
		if (histogram[i] > max_val)
		{
			//we've found intensities that is even more often present in the image 
			//than what we have discovered so far
			max_val=histogram[i]; //remember the count
			L=i;					//remember for what intensity
		}
	}

	//find the greatest used intensity
	int R=255;
	while ((R > 0) && (histogram[R] == 0)) --R;

	std::cout << "discovered maximum at L=" << L
		<< " and max intensity R=" << R << "\n";

	if (R <= L)
		std::cout << "analysis is probably going to fail...\n";

	float tmp=0.15 * (float)(R-L);
	return ( L + (int)tmp );
}
